设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

返回列表
查看: 91|回复: 5

[求助] 求助下批量偏移并倒角

[复制链接]

签到天数: 9 天

连续签到: 1 天

[LV.3]偶尔看看II

已领礼包: 9个

财富等级: 恭喜发财

发表于 2017-9-14 12:24:09 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
求助下批量偏移并倒角,左图的线不是PL线,希望批量偏移后倒圆角并删除原有线段



上一篇:晓东工具箱加载不起来
下一篇:求一个LSP插件

偏移

偏移
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复
百度谷歌雅虎搜狗搜搜有道360奇虎

使用道具 举报

签到天数: 339 天

连续签到: 1 天

[LV.8]以坛为家I

已领礼包: 51个

财富等级: 招财进宝

发表于 2017-9-14 15:29:10 | 显示全部楼层
试试,

偏移并圆角.gif

需要的函数去开源LISP函数库拷贝回去。
(XD::POLYLINE:SetRadius)LWPOLYLINE 顶点设置倒角半径
  1. (defun c:tt ()
  2.   (xdrx_begin)
  3.   (if (and (setq ss (ssget '((0 . "LINE,*POLYLINE"))))
  4.            (setq offset (getreal "\n输入偏移距离<退出>:"))
  5.            (setq fillet (getreal "\n输入圆角半径<退出>:"))
  6.            (setq ss (xdrx_entity_explode ss t))
  7.            (setq ss (xdrx_curve_intersectbreak ss))
  8.            (setq ss (xdrx_geom_searchregions ss 0))
  9.            (setq lst (mapcar
  10.                        '(lambda (x) (list (xdrx_getpropertyvalue x "area") x))
  11.                        (xdrx_pickset->ents ss)
  12.                      )
  13.                  lst (xd::list:sort lst '>)
  14.            )
  15.       )
  16.     (progn
  17.       (xdrx_entity_delete (cadar lst))
  18.       (setq lst (mapcar 'cadr (cdr lst)))
  19.       (setq
  20.         ret (mapcar '(lambda (x)
  21.                        (if (and        (setq ss1 (xdrx_curve_getoffsetcurves
  22.                                             x
  23.                                             (- (abs offset))
  24.                                           )
  25.                                 )
  26.                                 (= (sslength ss1) 1)
  27.                                 (setq e (ssname ss1 0))
  28.                                 (xdrx_curve_isclosed e)
  29.                            )
  30.                          (xd::polyline:setradius e -1 (abs fillet))
  31.                        )
  32.                      )
  33.                     lst
  34.             )
  35.       )
  36.       (cond
  37.         ((apply 'and ret)
  38.          (xdrx_prompt "\n成功偏移并圆角了" (length lst) " 条多段线.")
  39.         )
  40.         ((and (setq ret (xd::list:group ret 0.1)) (= (length ret) 2))
  41.          (xdrx_prompt "\n未全部成功.")
  42.         )
  43.         (t (xdrx_prompt "\n没有成功,检查数据."))
  44.       )
  45.     )
  46.   )
  47.   (xdrx_end)
  48.   (princ)
  49. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 9 天

连续签到: 1 天

[LV.3]偶尔看看II

已领礼包: 9个

财富等级: 恭喜发财

 楼主| 发表于 2017-9-14 19:19:01 | 显示全部楼层
大神,我试了,确实成功了,但是为什么一堆图形里操作的时候总是会丢失一个
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 923 天

连续签到: 3 天

[LV.10]以坛为家III

已领礼包: 39个

财富等级: 招财进宝

发表于 2017-9-14 20:52:34 | 显示全部楼层

你把你会丢的DWG,压缩传上来下。截图标明下哪个图形丢失了。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 9 天

连续签到: 1 天

[LV.3]偶尔看看II

已领礼包: 9个

财富等级: 恭喜发财

 楼主| 发表于 2017-9-14 23:17:56 | 显示全部楼层
文件附上,麻烦您了

03H-1.rar

34.94 KB, 下载次数: 0, 下载积分: D豆 -1 , 活跃度 1

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|Archiver|手机版|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

辽公网安备 21040202000005号

GMT+8, 2018-2-25 02:15 , Processed in 0.298688 second(s), 89 queries , Gzip On.

Powered by Discuz! X3.2

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表